<?php

    
/*
* $Id: zipur_core_compare_tool.php
* $Loc: /admin/
*
* Name: ZipurCoreCompareTool
* Version: 0.6.0
* Release Date: 10/31/2022
* Author: Preston Lord
* 	 phoenixaddons.com / @zipurman / plord@inetx.ca
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2020: Preston Lord - @zipurman - Intricate Networks Inc.
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with Zipur Bundler v0.2.3)
*/



    ini_set( 'memory_limit', '-1' );

    require 'includes/application_top.php';
    require 'includes/template_top.php';

    $use_file_open = 0;//set to 0 to use file_put_contents -- set to 1 to use fopen()


    function zcc_db_query( $query, $link = 'db' ) {

        if ( version_compare( '1.0.8.19', zcc_phoenix_version() ) > 0 ) {
            return tep_db_query( $query );
        } else {
            return $GLOBALS[ $link ]->query( $query );
        }

    }

    function zcc_fetch_array( $db_query ) {

        if ( version_compare( '1.0.8.19', zcc_phoenix_version() ) > 0 ) {
            return tep_db_fetch_array( $db_query );
        } else {
            return $db_query->fetch_assoc();
        }

    }


    function zcc_phoenix_version() {

        return trim( file_get_contents( DIR_FS_CATALOG . 'includes/version.php' ) );
    }

    function zipGetFileVersion( $filename ) {

        //get this tool version number from above content block. Dynamically created by Update Creator.
        $getcheckfile  = file_get_contents( $filename );
        $checkstartloc = strpos( $getcheckfile, 'Version' );
        $checkendloc   = strpos( $getcheckfile, "\n", $checkstartloc );
        $versiontext   = substr( $getcheckfile, $checkstartloc, $checkendloc - $checkstartloc + 2 );

        return preg_replace( '/[^0-9.]/', '', $versiontext );
    }

    /** Allow detect if OSC ot CE Phoenix
     *
     * @return bool
     */
    function zipCheckIfPhoenix() {

        if ( PROJECT_VERSION == 'OSCOM CE Phoenix' || PROJECT_VERSION == 'CE Phoenix' ) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * Adds bootstrap to admin tools if in OSC and not Phoenix
     */
    function zipOscCss() {

        if ( ! zipCheckIfPhoenix() ) {
            ?>
            <link rel="stylesheet"
                  href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/css/bootstrap.min.css"
                  integrity="sha256-aAr2Zpq8MZ+YA/D6JtRD3xtrwpEz2IqOS+pWD/7XKIw=" crossorigin="anonymous"/>
            <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.13.1/css/all.min.css"
                  integrity="sha256-2XFplPlrFClt0bIdPgpz8H7ojnk10H69xRqd9+uTShA=" crossorigin="anonymous"/>

            <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"
                    integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
                    crossorigin="anonymous"></script>
            <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/js/bootstrap.min.js"
                    integrity="sha256-OFRAJNoaD8L3Br5lglV7VyLRf0itmoBzWUoM+Sji4/8=" crossorigin="anonymous"></script>
            <style>
                #adminAppMenu {
                    font-size: 0.7rem;
                }

                .table-responsive {
                    padding: 0px 20px;
                }
            </style>
            <?php
        }
    }

    /**
     * Function to check POST/GET/COOKIE/SESSION vars and validate if needed with defaults
     *
     * @param        $var_to_check
     * @param        $default_value
     * @param string $checkformat
     * @param string $if_invalid_value
     * @param null   $current_val
     *
     * @return int|null
     */
    function zipVarCheck( $var_to_check, $default_value, $checkformat = "", $if_invalid_value = "", $current_val = null ) {

        if ( $current_val != null && $default_value == $current_val ) {
            $y = $current_val;
        } else if ( $current_val != "" && $current_val != null ) {
            $y = $current_val;
        } else {
            if ( isset( $_GET[ $var_to_check ] ) ) {
                $y = $_GET[ $var_to_check ];
            } elseif ( isset( $_POST[ $var_to_check ] ) ) {
                $y = $_POST[ $var_to_check ];
            } elseif ( isset( $_COOKIE[ $var_to_check ] ) ) {
                $y = $_COOKIE[ $var_to_check ];
            } elseif ( isset( $_SESSION[ $var_to_check ] ) ) {
                $y = $_SESSION[ $var_to_check ];
            } else {
                $y = $default_value;
            }
        }
        $checkformat = (string) $checkformat;

        if ( strpos( "$checkformat", "FILTER_VALIDATE_INT" ) !== false ) {
            if ( filter_var( $y, FILTER_VALIDATE_INT ) === 0 || ! filter_var( $y, FILTER_VALIDATE_INT ) === false ) {
                //all okay with $y
            } else {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_PIN" ) !== false ) {
            $opt = [ "options" => [ "regexp" => "/^[0-9]{4,8}$/" ] ];
            if ( filter_var( $y, FILTER_VALIDATE_REGEXP, $opt ) === false ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_FLOAT" ) !== false ) {
            $y = (float) $y;
            if ( ! filter_var( $y, FILTER_VALIDATE_FLOAT ) ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_DATE" ) !== false ) {
            if ( ! validateDate( $y, 'm/d/Y' ) ) {
                $y = $if_invalid_value;
            }
            //double check date length as weird values like 08/14/-18343974928 return true
            if ( strlen( $y ) != '10' ) {
                $y = $if_invalid_value;
            }

        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_EMAIL" ) !== false ) {
            if ( ! filter_var( $y, FILTER_VALIDATE_EMAIL ) ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_URL" ) !== false ) {
            if ( ! filter_var( $y, FILTER_VALIDATE_URL ) ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_ARRAY" ) !== false ) {
            if ( ! is_array( $y ) ) {
                if ( is_array( $if_invalid_value ) ) {
                    $y = $if_invalid_value;
                } else {
                    $y = [ $if_invalid_value ];
                }
            }
        }

        return $y;
    }

    /**
     * @param        $date
     * @param string $format
     *
     * @return bool
     */
    function validateDate( $date, $format = 'Y-m-d H:i:s' ) {

        $d = DateTime::createFromFormat( $format, $date, new DateTimeZone( CFG_TIME_ZONE ) );

        return $d && $d->format( $format ) == $date;
    }

    $zipCoreCompareVersion = zipGetFileVersion( basename( __FILE__ ) );
    $version               = zcc_phoenix_version();
    $osprod                = ( zipCheckIfPhoenix() ) ? 'CE Phoenix' : 'OS Commerce';
    $customadminpath       = basename( DIR_FS_ADMIN );
    $installedfiles        = [];
    $cleancorefiles        = [];
    $zip_added_files       = [];
    $zip_altered_files     = [];
    $zip_missing_files     = [];
    $updatesBaseDirectory  = DIR_FS_ADMIN . 'updates/';
    $deletecleancore       = zipVarCheck( "deletecleancore", '' );
    $installstep           = zipVarCheck( "installstep", 1, "FILTER_VALIDATE_INT", 1 );
    $versiondownload       = zipVarCheck( "versiondownload", 0, "FILTER_VALIDATE_INT", 0 );
    $zip_settings          = zipVarCheck( "zip_settings", 0, "FILTER_VALIDATE_INT", 0 );
    $swaplinkfile          = zipVarCheck( "swaplinkfile", '' );
    $zip_uninstall         = zipVarCheck( 'zip_uninstall', 0, 'FILTER_VALIDATE_INT', 0 );
    $zip_uninstall_now     = zipVarCheck( 'zip_uninstall_now', 0, 'FILTER_VALIDATE_INT', 0 );
    zipOscCss();

    /** Will loop through a directory root and delete all files - be careful !!
     * Taken from example https://paulund.co.uk/php-delete-directory-and-files-in-directory
     *
     * @param $dirname
     *
     * @return bool
     */
    function zipDeleteDirectory( $dirname ) {

        if ( is_dir( $dirname ) ) {
            $dir_handle = opendir( $dirname );
        }
        if ( ! $dir_handle ) {
            return false;
        }
        /** @noinspection PhpAssignmentInConditionInspection */
        while ( $file = readdir( $dir_handle ) ) {
            if ( $file != "." && $file != ".." ) {
                if ( ! is_dir( $dirname . "/" . $file ) ) {
                    unlink( $dirname . "/" . $file );
                } else {
                    zipDeleteDirectory( $dirname . '/' . $file );
                }
            }
        }
        closedir( $dir_handle );
        rmdir( $dirname );

        return true;
    }

    function zipurRow( $rowdata, $padding = 2, $style = '', $id = '', $class = '' ) {

        $leftdata  = '';
        $rightdata = '';

        $leftdata  .= ! empty( $rowdata[0]['text'] ) ? $rowdata[0]['text'] . ':' : '';
        $rightdata .= ! empty( $rowdata[1]['text'] ) ? $rowdata[1]['text'] . ':' : '';
        $rightdata .= ! empty( $rowdata[1]['field'] ) ? $rowdata[1]['field'] . ':' : '';

        $extrahtml = '';

        $style .= 'max-width: 100%; oveflow: hidden;';
        if ( ! empty( $style ) ) {
            $extrahtml .= ' style="' . $style . '" ';
        }
        if ( ! empty( $id ) ) {
            $extrahtml .= ' id="' . $id . '" ';
        }

        echo '<div class="form-group row pt-' . $padding . ' pb-' . $padding . ' ' . $class . '" ' . $extrahtml . '>';
        if ( $leftdata !== '' ) {
            echo '<label class="text-bold col-sm-3 text-left text-sm-right">' . $leftdata . '</label>';
            echo '<div class="col-sm-9">' . $rightdata . '</div>';

        } else if ( $rightdata !== '' ) {
            echo '<div class="col-sm-12">' . $rightdata . '</div>';
        }
        echo '</div>';
        ?>

        <?php

    }

    /**
     * Ass banner to top of zipur addons for easy support, docs, etc.
     */
    function zipAdBanner() {

        ?>
        <div style="text-align: right; padding: 0px 40px; margin-bottom: 10px;">
            This tool created by @zipurman (<a href="https://PhoenixAddons.com" target="_blank">PhoenixAddons.com</a>)
            <?php
                if ( ! zipCheckIfPhoenix() ) {
                    ?>
                    <div style="text-align: center; padding: 10px; background-color: #d04949; border: 1px solid #991e1e; color: #eee; width: 60%; margin: 10px auto; border-radius: 0.5rem;">
                        Upgrade to <a href="https://www.oscommerce.com/Products" target="_blank" style="color: #000;">CE
                            Phoenix</a> today to get the most out of your OSCommerce Experience.
                    </div>
                    <?php
                }
            ?>
        </div>
        <?php
    }

    /** Create a nested array from a directory root
     *
     * @param       $path
     * @param array $ignorefolders
     * @param int   $type
     * @param false $convertadmin
     */
    function zipGetDirArray( $path, $ignorefolders = [], $type = 0, $convertadmin = false ) {

        global $installedfiles, $cleancorefiles, $version, $customadminpath;
        $files = scandir( $path );
        foreach ( $files as $file ) {
            if ( $file == '.' || $file == '..' ) {
                //do nothing
            } else if ( is_dir( $path . '/' . $file ) ) {
                if ( ( in_array( basename( $file ), $ignorefolders ) ) ) {
                    //do nothing for ignored folders
                } else {
                    zipGetDirArray( $path . '/' . $file, $ignorefolders, $type, $convertadmin );
                }
            } else {
                if ( ( in_array( basename( $file ), $ignorefolders ) ) ) {
                    //do nothing for ignored files
                } else {
                    if ( empty( $type ) ) {
                        $keypath = $path . '/' . $file;
                        $keypath = str_replace( DIR_FS_CATALOG, '', $keypath );

                        if ( $convertadmin ) {
                            $keypath = preg_replace( '/^\/' . $customadminpath . '/', '/admin', $keypath, 1 );
                        }

                        $filedata = file_get_contents( $path . '/' . $file );
                        $filedata = str_replace( "\r\n", "\n", $filedata );
                        $filedata = preg_replace( "/\/\*.*\*\//s", "", $filedata );

                        $installedfiles[ $keypath ] = hash( 'md5', $filedata );
                        unset( $filedata );

                    } else if ( $type == 1 ) {
                        $keypath = $path . '/' . $file;
                        if ( version_compare( '1.0.8.0', trim( $version ) ) <= 0 ) {
                            $ospath = ( zipCheckIfPhoenix() ) ? 'PhoenixCart-' : 'oscommerce-';
                        } else {
                            $ospath = ( zipCheckIfPhoenix() ) ? 'CE-Phoenix-' : 'oscommerce-';
                        }
                        $ospath2 = ( zipCheckIfPhoenix() ) ? '' : '/catalog';
                        $keypath = str_replace( DIR_FS_ADMIN . 'clean_core/' . $ospath . trim( $version ) . $ospath2, '', $keypath );
                        $keypath = preg_replace( '/^\/admin/', '/' . $customadminpath . '', $keypath, 1 );

                        $filedata = file_get_contents( $path . '/' . $file );
                        $filedata = preg_replace( "/\/\*.*\*\//s", "", $filedata );
                        $filedata = str_replace( "\r\n", "\n", $filedata );

                        $cleancorefiles[ $keypath ] = hash( 'md5', $filedata );
                        unset( $filedata );

                    } else if ( $type == 2 ) {

                        //ignore any non-php files for catching patch versions
                        if ( strpos( $file, '.php' ) !== false ) {
                            $keypath          = $path . '/' . $file;
                            $cleancorefiles[] = $keypath;
                        }

                    }
                }
            }
        }
    }

    function zipButton( $text, $class, $link, $icon = '', $size = 'lg', $id = '' ) {

        $buttoncode = '';

        $extrahtml = '';
        if ( ! empty( $id ) ) {
            $extrahtml .= 'id="' . $id . '"';
        }

        if ( $link == 'submit' ) {
            $buttoncode .= '<button class="p-1 pr-4 mr-3 btn btn-' . $size . ' btn-' . $class . '" ' . $extrahtml . '>';
            if ( ! empty( $icon ) ) {
                $buttoncode .= '<i class="pr-2 pl-2 mr-1 fas ' . $icon . '"></i> ';
            }
            $buttoncode .= $text . '</button>';
        } else {
            $buttoncode .= '<a ' . $extrahtml . ' class="m-2 mr-4 pr-4 pl-2 btn btn-' . $size . ' btn-' . $class;
            $buttoncode .= '" href="' . $link . '">';
            if ( ! empty( $icon ) ) {
                $buttoncode .= '<i class="pr-2 pl-2 mr-1 fas ' . $icon . '"></i> ';
            }
            $buttoncode .= $text;
            $buttoncode .= '</a>';
        }

        return $buttoncode;
    }

    $oktoshowlisting = 1;

?>

<?php
    $zipFileVersion = zipGetFileVersion( basename( __FILE__ ) );

    zipAdBanner();
    function zipCEPBanner() {

        global $version, $zipFileVersion, $osprod;
        ?>
        <div class="bg-dark text-light p-4 m-0 mw-100 rounded">
            <div class="row">
                <div class="col-sm">
                    <a href="https://phoenixaddons.com" target="_blank"><img
                                src="https://phoenixaddons.com/wp-content/uploads/2020/08/CE-Phoenix_Addons_logo2.png"
                                style="width: 220px;"></a>
                </div>
                <div class="col-sm text-center">
                    <h4 class="display-7 mb-2"><?php echo HEADING_TITLE . '<br/><small>(' . $zipFileVersion . ')</small>'; ?></h4>
                </div>
                <div class="col-sm text-center">
                    <strong class="display-8 mb-2"><?php echo '(' . $osprod . ' ' . TABLE_HEADING_VERSION . ' ' . $version . ')'; ?></strong>
                </div>
            </div>
        </div>
        <?php
    }

    zipCEPBanner();

    if ( ! empty( $deletecleancore ) ) {
        $cleancorefileitemstodelete = scandir( DIR_FS_ADMIN . 'clean_core/' );
        if ( ! empty( $cleancorefileitemstodelete ) ) {
            foreach ( $cleancorefileitemstodelete as $cleancorefileitemstodeleteitem ) {
                if ( $cleancorefileitemstodeleteitem == '.' || $cleancorefileitemstodeleteitem == '..' ) {
                    //do nothing
                } else {
                    $thisdeletecleancoreitem = DIR_FS_ADMIN . 'clean_core/' . $cleancorefileitemstodeleteitem;
                    $deletehash              = hash( 'sha256', $thisdeletecleancoreitem );
                    if ( $deletecleancore == $deletehash ) {
                        zipDeleteDirectory( $thisdeletecleancoreitem );
                    }
                }
            }
        }
        $oktoshowlisting = 0;
        echo '<br/>' . ZIPUR_CODE_COMPARE_FILE_VERSION_DELETED . ' <a href="zipur_core_compare_tool.php">' . ZIPUR_CODE_COMPARE_CONTINUE . '</a>';
    }

    if ( ! empty( $oktoshowlisting ) ) {
        echo '<br/><p>' . ZIPUR_CODE_COMPARE_DESCRIPTION . '</p>';

        if ( ! zipCheckIfPhoenix() ) {

            $versionpath      = 'oscommerce-';
            $newurl           = '';
            $extracatalogpath = '/catalog';

        } else {

            if ( version_compare( '1.0.8.0', trim( $version ) ) <= 0 ) {
                $newurl      = 'https://codeload.github.com/CE-PhoenixCart/PhoenixCart/zip/' . trim( $version );
                $versionpath = 'PhoenixCart-';

            } else {
                $newurl      = 'https://codeload.github.com/gburton/CE-Phoenix/zip/' . trim( $version );
                $versionpath = 'CE-Phoenix-';

            }

            $extracatalogpath = '';

        }

        if ( ! file_exists( DIR_FS_ADMIN . 'clean_core/' . $versionpath . trim( $version ) ) ) {
            if ( empty( $newurl ) ) {

                echo 'You need to download a full copy of OS Commerce ' . trim( $version ) . ' from <a href="https://www.oscommerce.com/Products" target="_blank">www.oscommerce.com</a> and unzip the file to <br/>' . DIR_FS_ADMIN . 'clean_core/oscommerce-' . trim( $version ) . '/';

            } else {
                if ( ! empty( $installstep ) ) {
                    if ( ! file_exists( DIR_FS_ADMIN . 'clean_core' ) ) {
                        if ( ! mkdir( DIR_FS_ADMIN . 'clean_core', 0700 ) ) {
                            echo '<span class="text-danger">' . ZIPUR_CODE_COMPARE_DIRECTORY_CREATE_ERROR . '</span>';
                        }
                    }

                    $newpath = DIR_FS_ADMIN . 'clean_core/' . trim( $version ) . '.zip';
                    if ( ! empty( $use_file_open ) ) {
                        $fp = fopen( $newpath, 'w+' );
                    }
                    $ch = curl_init();
                    curl_setopt( $ch, CURLOPT_URL, $newurl );
                    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, false );
                    curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
                    curl_setopt( $ch, CURLOPT_CONNECTTIMEOUT, 10 );
                    if ( ! empty( $use_file_open ) ) {
                        curl_setopt( $ch, CURLOPT_FILE, $fp );
                    } else {
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                    }

                    if ( ! empty( $use_file_open ) ) {
                        curl_exec( $ch );
                        curl_close( $ch );
                        fclose( $fp );
                    } else {
                        $file = curl_exec( $ch );
                        curl_close( $ch );
                        if ( ! empty( $file ) ) {
                            file_put_contents( $newpath, $file );
                            echo '<span class="text-success"><i class="fas fa-check"></i></span> ';
                        } else {
                            echo '<span class="text-danger"><i class="fas fa-exclamation-triangle"></i></span> ';

                        }
                    }

                    if ( ! file_exists( $newpath ) ) {
                        echo '<span class="text-danger">' . ZIPUR_CODE_COMPARE_DOWNLOAD_ERROR . ' (' . $versionpath . trim( $version ) . '.zip)</span>';
                    } else {
                        echo '<span class="text-success">' . ZIPUR_CODE_COMPARE_DOWNLOAD_SUCCESS . ' (' . $versionpath . trim( $version ) . '.zip)</span>';
                        $zip = new ZipArchive;
                        $res = $zip->open( $newpath );
                        if ( $res === true ) {
                            $zip->extractTo( DIR_FS_ADMIN . 'clean_core/' );
                            $zip->close();
                            echo '<br/><span class="text-success">' . ZIPUR_CODE_COMPARE_UNZIP_SUCCESS . '</span>';
                            unlink( $newpath );//deletes downloaded zip
                            echo '<br/><a href="zipur_core_compare_tool.php">' . ZIPUR_CODE_COMPARE_CONTINUE . '</a>';
                        } else {
                            echo '<br/><span class="text-danger">' . ZIPUR_CODE_COMPARE_UNZIP_FAILED . ' (' . $newpath . ')</span>';
                        }

                    }

                } else {

                    echo ZIPUR_CODE_COMPARE_VERSION_FOLDER_ERROR;
                    ?>
                    <nav class="navbar navbar-light bg-light">
                        <a class="btn btn-sm btn-outline-secondary"
                           href="zipur_core_compare_tool.php"><?php echo ZIPUR_CODE_COMPARE_NO; ?></a>
                        <a class="btn btn-sm btn-outline-secondary"
                           href="zipur_core_compare_tool.php?versiondownload=1"><?php echo ZIPUR_CODE_COMPARE_YES; ?></a>
                    </nav>
                    <?php
                }
            }

        } else if ( ! empty( $zip_uninstall_now ) ) {

            zcc_db_query( "DELETE FROM configuration WHERE configuration_key LIKE 'ZIPUR_CORECOMPARE_%'" );
            ?>
            <div class="alert alert-warning mt-4 mb-4" role="alert">
                <?php
                    zipDeleteDirectory( DIR_FS_ADMIN . 'clean_core/' );
                    echo ZIPUR_CODE_COMPARE_BUTTON_UNINSTALL_CONFIRMED;
                    echo ' ' . zipButton( ZIPUR_CODE_COMPARE_BUTTON_DASHBOARD, 'secondary', 'index.php', 'fa-undo', 'sm' );
                ?>
            </div>
            <?php

        } else if ( ! empty( $zip_uninstall ) ) {
            ?>

            <div class="navbar-light bg-light text-right">
                <?php
                    echo zipButton( ZIPUR_CODE_COMPARE_BACK, 'secondary', 'zipur_core_compare_tool.php', 'fa-undo', 'sm' );
                ?>
            </div>

            <div class="alert alert-warning mt-4 mb-4" role="alert">
                <?php echo ZIPUR_CODE_COMPARE_UNINSTALL_WARNING; ?>
            </div>

            <div class="navbar-light bg-light text-right">
                <?php
                    echo zipButton( ZIPUR_CODE_COMPARE_BUTTON_UNINSTALL_NOW, 'warning', 'zipur_core_compare_tool.php?zip_uninstall_now=1', 'fa-undo', 'sm' );
                ?>
            </div>
            <?php

        } else if ( ! empty( $zip_settings ) ) {

            $zipexcludefolders = zipVarCheck( "zipexcludefolders", '--' );
            $manual_query      = zcc_db_query( "SELECT * FROM configuration WHERE configuration_key='ZIPUR_CORECOMPARE_EXCLUDE'" );
            $result            = zcc_fetch_array( $manual_query );

            if ( $zipexcludefolders != '--' ) {

                if ( empty( $result ) ) {
                    zcc_db_query( "INSERT INTO configuration (configuration_title, configuration_key, configuration_value) VALUES ('Zipur Code Compare', 'ZIPUR_CORECOMPARE_EXCLUDE','{$zipexcludefolders}' );" );
                } else {
                    zcc_db_query( "UPDATE configuration SET configuration_value='{$zipexcludefolders}' WHERE configuration_key='ZIPUR_CORECOMPARE_EXCLUDE';" );
                }
                $result['configuration_value'] = $zipexcludefolders;

            }

            ?>
            <form action="zipur_core_compare_tool.php" method="post">
                <div class="navbar-light bg-light text-right">

                    <?php
                        echo zipButton( ZIPUR_CODE_COMPARE_BACK, 'secondary', 'zipur_core_compare_tool.php', 'fa-undo', 'sm' );
                    ?>

                </div>
                <?php

                    zipurRow( [
                        [ 'text' => ZIPUR_CODE_COMPARE_EXCLUDE, ],
                        [
                            'field' => '<input type="text" name="zipexcludefolders" id="zipexcludefolders" value="' . $result['configuration_value'] . '" size="50" /> (separate folder names with a comma)',
                        ],
                    ] );

                ?>
                <div class="navbar-light bg-light text-center">

                    <?php
                        echo zipButton( ZIPUR_CODE_COMPARE_SAVE_CHANGES, 'success', 'submit', 'fa-save', 'sm', 'productsabebutton' );
                    ?>

                </div>
                <input type="hidden" name="zip_settings" value="1"/>
            </form>

            <div class="navbar-light bg-light text-right">
                <?php
                    echo zipButton( ZIPUR_CODE_COMPARE_BUTTON_UNINSTALL, 'secondary', 'zipur_core_compare_tool.php?zip_uninstall=1', 'fa-trash-alt', 'sm' );
                ?>
            </div>
            <?php

        } else {

            $manual_query = zcc_db_query( "SELECT * FROM configuration WHERE configuration_key='ZIPUR_CORECOMPARE_EXCLUDE'" );
            $result       = zcc_fetch_array( $manual_query );
            $exclude1     = [
                'images',
                'imported',
                'updates',
                'install',
                'old',
                'clean_core',
                'upgrader',
                'download',
                'migrate',
                '1080',
                'testing',
                'UNITTESTS',
                'xdebug',
                'composer',
                'vendor',
                'README',
                'README.md',
            ];
            $exclude2     = [
                'images',
                'imported',
                'updates',
                'old',
                'clean_core',
                '1080',
                'upgrader',
                'download',
                'migrate',
                'testing',
                'UNITTESTS',
                'xdebug',
                'composer',
                'vendor',
                'README',
                'README.md',
            ];
            $excluding    = '';
            if ( ! empty( $result ) ) {
                $excluding = '<br/>' . ZIPUR_CODE_COMPARE_EXCLUDE . ': ' . $result['configuration_value'];
                $additems  = explode( ',', $result['configuration_value'] );
                foreach ( $additems as $additem ) {
                    $exclude1[] = "{$additem}";
                    $exclude2[] = "{$additem}";
                }
            }

            //setup array for existing install
            zipGetDirArray( DIR_FS_CATALOG, $exclude1, 0 );

            $cleanpath = 'clean_core/' . $versionpath . trim( $version ) . $extracatalogpath;
            echo $customadminpath . '/' . $cleanpath . $excluding . '<br/>';
            //setup array for clean core (same version)
            zipGetDirArray( DIR_FS_ADMIN . 'clean_core/' . $versionpath . trim( $version ) . $extracatalogpath, $exclude2, 1 );

            ?>
            <div class="navbar-light bg-light text-right">

                <?php
                    echo zipButton( ZIPUR_CODE_COMPARE_SETTINGS, 'secondary', 'zipur_core_compare_tool.php?zip_settings=1', 'fa-cogs', 'sm' );
                ?>

            </div>
            <?php

            foreach ( $installedfiles as $installedfilekey => $installedfile ) {
                if ( empty( $cleancorefiles[ $installedfilekey ] ) ) {
                    $zip_added_files[] = $installedfilekey;
                } else if ( $cleancorefiles[ $installedfilekey ] != $installedfile ) {

                    if ( ! empty( $swaplinkfile ) ) {
                        $swaplinkfileis = hash( 'sha256', $installedfilekey );
                        if ( $swaplinkfileis == $swaplinkfile ) {
                            $installedfilekeyfrom = preg_replace( '/^\/' . $customadminpath . '/', 'admin', $installedfilekey, 1 );
                            $installedfilekeyto   = preg_replace( '/^\//', '', $installedfilekey, 1 );
                            copy( DIR_FS_ADMIN . $cleanpath . '/' . $installedfilekeyfrom, DIR_FS_CATALOG . $installedfilekeyto );
                        }
                    }

                    $zip_altered_files[] = $installedfilekey;
                }
            }

            foreach ( $cleancorefiles as $cleancorefilekey => $cleancorefile ) {
                if ( empty( $installedfiles[ $cleancorefilekey ] ) ) {

                    if ( ! empty( $swaplinkfile ) ) {
                        $swaplinkfileis = hash( 'sha256', $cleancorefilekey );
                        if ( $swaplinkfileis == $swaplinkfile ) {

                            $installedfilekeyfrom = preg_replace( '/^\/' . $customadminpath . '/', 'admin', $cleancorefilekey, 1 );

                            $installedfilekeyto = preg_replace( '/^\//', '', $cleancorefilekey, 1 );

                            copy( DIR_FS_ADMIN . $cleanpath . '/' . $installedfilekeyfrom, DIR_FS_CATALOG . $installedfilekeyto );
                        }
                    }

                    $zip_missing_files[] = $cleancorefilekey;
                }
            }

            /** Generate report row
             *
             * @param     $class
             * @param     $title
             * @param     $filepath
             * @param int $padding1
             * @param int $padding2
             *
             * @return string
             */
            function zipReportRow( $class, $title, $filepath, $padding1 = 0, $padding2 = 0 ) {

                return <<<html
<tr>
    <td class=" p-{$padding1} text-right {$class}">{$title}&nbsp;</td>
    <td class=" p-{$padding2}">&nbsp;{$filepath}</td>
</tr>
html;

            }

            ?>

            <ul class="nav nav-tabs" id="zipReportTab" role="tablist">
                <li class="nav-item">
                    <a class="nav-link active" id="added-tab" data-toggle="tab" href="#added" role="tab"
                       aria-controls="added"
                       aria-selected="true"><?php echo ZIPUR_CODE_COMPARE_FILE_ADDED; ?></a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" id="altered-tab" data-toggle="tab" href="#altered" role="tab"
                       aria-controls="altered"
                       aria-selected="false"><?php echo ZIPUR_CODE_COMPARE_FILE_ALTERED; ?></a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" id="removed-tab" data-toggle="tab" href="#removed" role="tab"
                       aria-controls="removed"
                       aria-selected="false"><?php echo ZIPUR_CODE_COMPARE_FILE_REMOVED; ?></a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" id="versions-tab" data-toggle="tab" href="#versions" role="tab"
                       aria-controls="versions"
                       aria-selected="false"><?php echo ZIPUR_CODE_COMPARE_FILE_VERSIONS; ?></a>
                </li>
            </ul>
            <div class="tab-content" id="zipReportTabContent">
                <div class="tab-pane fade show active" id="added" role="tabpanel" aria-labelledby="added-tab">
                    <table class="table">
                        <tbody>
                        <?php
                            foreach ( $zip_added_files as $zip_added_file ) {
                                echo zipReportRow( 'text-warning', ZIPUR_CODE_COMPARE_FILE_ADDED, $zip_added_file );
                            }
                        ?>
                        </tbody>
                    </table>
                </div>
                <div class="tab-pane fade" id="altered" role="tabpanel" aria-labelledby="altered-tab">
                    <table class="table">
                        <tbody>

                        <?php

                            foreach ( $zip_altered_files as $zip_altered_file ) {
                                $swaplinkfileis = hash( 'sha256', $zip_altered_file );
                                $swaplink       = ' <a href="zipur_core_compare_tool.php?swaplinkfile=' . $swaplinkfileis . '" title="Replace File with Original"><i class="fas fa-retweet"></i></a>';

                                if ( ! empty( $swaplinkfile ) ) {
                                    if ( $swaplinkfileis == $swaplinkfile ) {
                                        $swaplink = ' (<span class="text-success">' . ZIPUR_CODE_COMPARE_FILE_REPLACED . '</span>)';
                                    }
                                }
                                echo zipReportRow( 'text-danger', ZIPUR_CODE_COMPARE_FILE_ALTERED, $zip_altered_file . $swaplink );
                            }
                        ?>
                        </tbody>
                    </table>
                </div>
                <div class="tab-pane fade" id="removed" role="tabpanel" aria-labelledby="removed-tab">
                    <table class="table">
                        <tbody>
                        <?php
                            foreach ( $zip_missing_files as $zip_missing_file ) {

                                $swaplinkfileis = hash( 'sha256', $zip_missing_file );
                                $swaplink       = ' <a href="zipur_core_compare_tool.php?swaplinkfile=' . $swaplinkfileis . '" title="Replace File with Original"><i class="fas fa-retweet"></i></a>';

                                if ( ! empty( $swaplinkfile ) ) {
                                    if ( $swaplinkfileis == $swaplinkfile ) {
                                        $swaplink = ' (<span class="text-success">' . ZIPUR_CODE_COMPARE_FILE_REPLACED . '</span>)';
                                    }
                                }

                                echo zipReportRow( 'text-danger', ZIPUR_CODE_COMPARE_FILE_REMOVED, $zip_missing_file . $swaplink );
                            }
                        ?>
                        </tbody>
                    </table>
                </div>
                <div class="tab-pane fade" id="versions" role="tabpanel" aria-labelledby="versions-tab">
                    <table class="table">
                        <tbody>
                        <?php
                            $cleancorefileitems = scandir( DIR_FS_ADMIN . 'clean_core/' );
                            if ( ! empty( $cleancorefileitems ) ) {
                                ?>
                                <table class="table">
                                    <tbody>
                                    <?php
                                        foreach ( $cleancorefileitems as $cleancorefileitem ) {
                                            if ( $cleancorefileitem == '.' || $cleancorefileitem == '..' ) {
                                                //do nothing
                                            } else {
                                                $deletehash = hash( 'sha256', DIR_FS_ADMIN . 'clean_core/' . $cleancorefileitem );
                                                echo zipReportRow( 'text-info', '<a class="btn btn-sm btn-outline-secondary mt-2 ml-2" href="zipur_core_compare_tool.php?deletecleancore=' . $deletehash . '">' . ZIPUR_CODE_COMPARE_DELETE . '</a>', DIR_FS_ADMIN . 'clean_core/' . $cleancorefileitem, 0, 6 );
                                            }
                                        }
                                    ?>
                                    </tbody>
                                </table>
                                <?php
                            }
                        ?>
                        </tbody>
                    </table>
                </div>
            </div>
            <?php
        }
    }

    require 'includes/template_bottom.php';
    require 'includes/application_bottom.php';
?>
